diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
index e3a692cb7..cb63be6bc 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRailDetector.java
@@ -6,34 +6,32 @@ import java.util.Random;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.primitives.AABBd;
 
 public class BlockLogicRailDetector extends BlockLogicRail {
-    public BlockLogicRailDetector(@NotNull Block<?> block)
-    {
+    public BlockLogicRailDetector(@NotNull Block<?> block) {
         super(block, true);
         block.setTicking(true);
     }
 
     @Override
-    public int tickDelay()
-    {
+    public int tickDelay() {
         return 20;
     }
 
     @Override
-    public boolean isSignalSource()
-    {
+    public boolean isSignalSource() {
         return true;
     }
 
     @Override
-    public void onEntityCollision(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity) {
-        if(world.isClientSide) {
+    public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+        if (world.isClientSide) {
             return;
         }
         int meta = world.getBlockData(tilePos);
@@ -43,8 +41,8 @@ public class BlockLogicRailDetector extends BlockLogicRail {
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
-        if(world.isClientSide) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.isClientSide) {
             return;
         }
         int meta = world.getBlockData(tilePos);
@@ -54,42 +52,41 @@ public class BlockLogicRailDetector extends BlockLogicRail {
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         return (source.getBlockData(tilePos) & MASK_POWERED) != 0;
     }
 
     @Override
-    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
-        if((world.getBlockData(tilePos) & MASK_POWERED) == 0) {
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
+        if ((world.getBlockData(tilePos) & MASK_POWERED) == 0) {
             return false;
         } else {
             return side == Side.TOP;
         }
     }
 
-    private void checkForMinecart(@NotNull World world, @NotNull TilePos tilePos, int meta) {
+    private void checkForMinecart(@NotNull World world, @NotNull TilePosc tilePos, int meta) {
         boolean isPowered = (meta & MASK_POWERED) != 0;
         boolean minecartPresent = false;
         float offset = 0.125f;
-        List<EntityMinecart> list = world.getEntitiesWithinAABB(EntityMinecart.class,
-            AABB.fromPool(tilePos.x + offset, tilePos.y + offset, tilePos.z + offset, tilePos.x + 1 - offset, tilePos.y + 1 - offset, tilePos.z + 1 - offset));
-        if(!list.isEmpty()) {
+        List<EntityMinecart> list = world.getEntitiesWithinAABB(EntityMinecart.class, new AABBd(tilePos.x() + offset, tilePos.y() + offset, tilePos.z() + offset, tilePos.x() + 1 - offset, tilePos.y() + 1 - offset, tilePos.z() + 1 - offset));
+        if (!list.isEmpty()) {
             minecartPresent = true;
         }
-        if(minecartPresent && !isPowered) {
+        if (minecartPresent && !isPowered) {
             // Set rail to powered
             world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
             world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.down(), id());
+            world.notifyBlocksOfNeighborChange(tilePos.down(new TilePos()), id());
             world.markBlockDirty(tilePos);
-        } else if(!minecartPresent && isPowered) {
+        } else if (!minecartPresent && isPowered) {
             // Set rail to unpowered
             world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
             world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.down(), id());
+            world.notifyBlocksOfNeighborChange(tilePos.down(new TilePos()), id());
             world.markBlockDirty(tilePos);
         }
-        if(minecartPresent) {
+        if (minecartPresent) {
             // Schedule update if minecart in rail
             world.scheduleBlockUpdate(tilePos, id(), tickDelay());
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
index 5b99e16af..d8b6957d8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRedstone.java
@@ -6,95 +6,93 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
-public class BlockLogicRedstone extends BlockLogic
-{
-	public BlockLogicRedstone(@NotNull Block<?> block, @NotNull Material material)
-    {
-		super(block, material);
-	}
+public class BlockLogicRedstone extends BlockLogic {
+    public BlockLogicRedstone(@NotNull Block<?> block, @NotNull Material material) {
+        super(block, material);
+    }
 
-	@Override
-    public boolean isSignalSource()
-    {
+    @Override
+    public boolean isSignalSource() {
         return true;
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         return true;
     }
 
     @Override
-    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return true;
     }
 
     @Override
-	public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos)
-    {
-        for (Direction dir : Direction.directions){
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir), id());
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
+        for (Direction dir : Direction.directions) {
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), id());
         }
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data)
-    {
-        for (Direction dir : Direction.directions){
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir), id());
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        TilePos queryPos = new TilePos();
+        for (Direction dir : Direction.directions) {
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, queryPos), id());
         }
     }
 
-    
+
     @Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         Random random = world.rand;
 
         final int redstoneBrightness = 10;
 
         final double d = 0.0625;
-        for (Direction dir : Direction.directions){
-            double px = (double) tilePos.x + random.nextFloat();
-            double py = (double) tilePos.y + random.nextFloat();
-            double pz = (double) tilePos.z + random.nextFloat();
-            TilePos p = tilePos.add(dir.getOpposite());
-            switch (dir){
+        TilePos queryPos = new TilePos();
+        for (Direction dir : Direction.directions) {
+            double px = (double) tilePos.x() + random.nextFloat();
+            double py = (double) tilePos.y() + random.nextFloat();
+            double pz = (double) tilePos.z() + random.nextFloat();
+            switch (dir) {
                 case DOWN:
-                    if (!world.isBlockOpaqueCube(p)) {
-                        py = (tilePos.y + 1) + d;
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                        py = (tilePos.y() + 1) + d;
                     }
                     break;
                 case UP:
-                    if (!world.isBlockOpaqueCube(p)) {
-                        py = (tilePos.y + 0) - d;
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                        py = (tilePos.y() + 0) - d;
                     }
                     break;
                 case NORTH:
-                    if (!world.isBlockOpaqueCube(p)) {
-                        pz = (tilePos.z + 1) + d;
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                        pz = (tilePos.z() + 1) + d;
                     }
                     break;
                 case SOUTH:
-                    if (!world.isBlockOpaqueCube(p)) {
-                        pz = (tilePos.z + 0) - d;
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                        pz = (tilePos.z() + 0) - d;
                     }
                     break;
                 case WEST:
-                    if (!world.isBlockOpaqueCube(p)) {
-                        px = (tilePos.x + 1) + d;
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                        px = (tilePos.x() + 1) + d;
                     }
                     break;
                 case EAST:
-                    if (!world.isBlockOpaqueCube(p)) {
-                        px = (tilePos.x + 0) - d;
+                    if (!world.isBlockOpaqueCube(tilePos.add(dir.getOpposite(), queryPos))) {
+                        px = (tilePos.x() + 0) - d;
                     }
                     break;
             }
-            if (px < tilePos.x || px > (tilePos.x + 1) || py < 0.0D || py > (tilePos.y + 1) || pz < tilePos.z || pz > (tilePos.z + 1)) {
+            if (px < tilePos.x() || px > (tilePos.x() + 1) || py < 0.0D || py > (tilePos.y() + 1) || pz < tilePos.z() || pz > (tilePos.z() + 1)) {
                 world.spawnParticle("reddust", px, py, pz, 0, 0, 0, redstoneBrightness);
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
index cfa98c69a..f769c2e54 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicRepeater.java
@@ -2,7 +2,7 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.entity.Mob;
@@ -15,12 +15,13 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
-public class BlockLogicRepeater extends BlockLogic
-{
+
+public class BlockLogicRepeater extends BlockLogic {
     public static final double[] torchPosOffset = {
         -0.0625D, 0.0625D, 0.1875D, 0.3125D
     };
@@ -36,49 +37,46 @@ public class BlockLogicRepeater extends BlockLogic
 
     public final boolean isRepeaterPowered;
 
-	public BlockLogicRepeater(@NotNull Block<?> block, boolean isPowered)
-    {
-        super(block, Material.decoration);
+    public BlockLogicRepeater(@NotNull Block<?> block, boolean isPowered) {
+        super(block, Materials.DECORATION);
         this.isRepeaterPowered = isPowered;
         setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-	public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos)
-    {
-        return world.canPlaceOnSurfaceOfBlock(tilePos.down()) && super.canPlaceAt(world, tilePos);
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
+        return world.canPlaceOnSurfaceOfBlock(tilePos.down(new TilePos())) && super.canPlaceAt(world, tilePos);
     }
 
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
-        return new ItemStack[] { new ItemStack(Items.REPEATER) };
+        return new ItemStack[]{new ItemStack(Items.REPEATER)};
     }
 
     @Override
-    public boolean canStay(@NotNull World world, @NotNull TilePos tilePos) {
-        return world.canPlaceOnSurfaceOfBlock(tilePos.down()) && super.canStay(world, tilePos);
+    public boolean canStay(@NotNull World world, @NotNull TilePosc tilePos) {
+        return world.canPlaceOnSurfaceOfBlock(tilePos.down(new TilePos())) && super.canStay(world, tilePos);
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
         int meta = world.getBlockData(tilePos);
         boolean powered = isGettingPower(world, tilePos, meta);
-        if(this.isRepeaterPowered && !powered) {
+        if (this.isRepeaterPowered && !powered) {
             world.setBlockIdDataNotify(tilePos, Blocks.REPEATER_IDLE.id(), meta);
-        } else if(!this.isRepeaterPowered) {
+        } else if (!this.isRepeaterPowered) {
             world.setBlockIdDataNotify(tilePos, Blocks.REPEATER_ACTIVE.id(), meta);
-            if(!powered) {
+            if (!powered) {
                 int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
                 world.scheduleBlockUpdate(tilePos, Blocks.REPEATER_ACTIVE.id(), tickDelayMap[tickDelay] * 2);
             }
@@ -94,20 +92,20 @@ public class BlockLogicRepeater extends BlockLogic
     // Cause block updates on the target block when removing a repeater,
     // which prevents redstone components on the other wide of the target block from staying powered.
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         Side back = getSideFromMeta(data);
         Side front = back.getOpposite();
-        world.notifyBlocksOfNeighborChange(tilePos.add(front.getDirection()), id());
+        world.notifyBlocksOfNeighborChange(tilePos.add(front.getDirection(), new TilePos()), id());
     }
 
     @Override
-    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return isEmittingSignal(world, tilePos, side);
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
-        if(!this.isRepeaterPowered) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        if (!this.isRepeaterPowered) {
             return false;
         }
         return side == getSideFromMeta(source.getBlockData(tilePos));
@@ -124,8 +122,8 @@ public class BlockLogicRepeater extends BlockLogic
     }
 
     @Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
-        if(!canStay(world, tilePos)) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+        if (!canStay(world, tilePos)) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
             return;
@@ -133,25 +131,24 @@ public class BlockLogicRepeater extends BlockLogic
         int meta = world.getBlockData(tilePos);
         boolean powered = isGettingPower(world, tilePos, meta);
         int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
-        if(this.isRepeaterPowered && !powered) {
+        if (this.isRepeaterPowered && !powered) {
             world.scheduleBlockUpdate(tilePos, id(), tickDelayMap[tickDelay] * 2);
-        } else if(!this.isRepeaterPowered && powered) {
+        } else if (!this.isRepeaterPowered && powered) {
             world.scheduleBlockUpdate(tilePos, id(), tickDelayMap[tickDelay] * 2);
         }
     }
 
-    private boolean isGettingPower(@NotNull World world, @NotNull TilePos tilePos, int meta)
-    {
+    private boolean isGettingPower(@NotNull World world, @NotNull TilePosc tilePos, int meta) {
         Side direction = getSideFromMeta(meta);
         if (direction.isVertical()) return false;
 
-        TilePos p = tilePos.add(direction.getDirection());
+        TilePos p = tilePos.add(direction.getDirection(), new TilePos());
         return world.hasSignal(p, direction) || (world.getBlockId(p) == Blocks.WIRE_REDSTONE.id() && (world.getBlockData(p) & BlockLogicWireRedstone.MASK_POWER) != 0);
     }
 
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         int metadata = world.getBlockData(tilePos);
         int tickDelay = (metadata & MASK_TICK_DELAY) >> 2;
         tickDelay = ((tickDelay + 1) << 2) & MASK_TICK_DELAY;
@@ -160,7 +157,7 @@ public class BlockLogicRepeater extends BlockLogic
     }
 
     @Override
-    public void onActivatorInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
+    public void onActivatorInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull TileEntityActivator activator, @NotNull Direction direction) {
         int metadata = world.getBlockData(tilePos);
         int tickDelay = (metadata & MASK_TICK_DELAY) >> 2;
         tickDelay = ((tickDelay + 1) << 2) & MASK_TICK_DELAY;
@@ -168,79 +165,77 @@ public class BlockLogicRepeater extends BlockLogic
     }
 
     @Override
-    public void onPlacedByMob(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
-		int l = mob.getHorizontalPlacementDirection(side).index;
-		world.setBlockDataNotify(tilePos, l);
-		if(isGettingPower(world, tilePos, l)) {
-		    world.scheduleBlockUpdate(tilePos, id(), 1);
-		}
+    public void onPlacedByMob(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, @NotNull Mob mob, double xHit, double yHit) {
+        int l = mob.getHorizontalPlacementDirection(side).index;
+        world.setBlockDataNotify(tilePos, l);
+        if (isGettingPower(world, tilePos, l)) {
+            world.scheduleBlockUpdate(tilePos, id(), 1);
+        }
     }
 
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         if (!side.isHorizontal()) side = Side.NORTH;
         int l = side.getDirection().index;
         world.setBlockDataNotify(tilePos, l);
-        if(isGettingPower(world, tilePos, l))
-        {
+        if (isGettingPower(world, tilePos, l)) {
             world.scheduleBlockUpdate(tilePos, id(), 1);
         }
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
-	@Override
-	public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
-		if (!this.isRepeaterPowered) {
-			return;
-		}
-		int meta = world.getBlockData(tilePos);
-		double px = (tilePos.x + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
-		double py = (tilePos.y + 0.4D) + (rand.nextFloat() - 0.5D) * 0.2D;
-		double pz = (tilePos.z + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
-		
-		double xOffset = 0.0;
-		double zOffset = 0.0;
+    @Override
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
+        if (!this.isRepeaterPowered) {
+            return;
+        }
+        int meta = world.getBlockData(tilePos);
+        double px = (tilePos.x() + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double py = (tilePos.y() + 0.4D) + (rand.nextFloat() - 0.5D) * 0.2D;
+        double pz = (tilePos.z() + 0.5D) + (rand.nextFloat() - 0.5D) * 0.2D;
+
+        double xOffset = 0.0;
+        double zOffset = 0.0;
 
         final int redstoneBrightness = 15;
-		
-		if (rand.nextInt(2) == 0) {
-			switch (getSideFromMeta(meta)) {
+
+        if (rand.nextInt(2) == 0) {
+            switch (getSideFromMeta(meta)) {
                 case SOUTH:
-				    zOffset = -0.3125D;
-				    break;
+                    zOffset = -0.3125D;
+                    break;
                 case NORTH:
-				    zOffset = 0.3125D;
-				    break;
+                    zOffset = 0.3125D;
+                    break;
                 case EAST:
-				    xOffset = -0.3125D;
-				    break;
+                    xOffset = -0.3125D;
+                    break;
                 case WEST:
-				    xOffset = 0.3125D;
-				    break;
-			}
-		} else {
-			int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
-			switch (getSideFromMeta(meta)) {
+                    xOffset = 0.3125D;
+                    break;
+            }
+        } else {
+            int tickDelay = (meta & MASK_TICK_DELAY) >> 2;
+            switch (getSideFromMeta(meta)) {
                 case SOUTH:
-				    zOffset = torchPosOffset[tickDelay];
-				    break;
+                    zOffset = torchPosOffset[tickDelay];
+                    break;
                 case NORTH:
-				    zOffset = -torchPosOffset[tickDelay];
-				    break;
+                    zOffset = -torchPosOffset[tickDelay];
+                    break;
                 case EAST:
-				    xOffset = torchPosOffset[tickDelay];
-				    break;
+                    xOffset = torchPosOffset[tickDelay];
+                    break;
                 case WEST:
-				    xOffset = -torchPosOffset[tickDelay];
-				    break;
-			}
-		}
-		world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, 0, 0, 0, redstoneBrightness);
-	}
+                    xOffset = -torchPosOffset[tickDelay];
+                    break;
+            }
+        }
+        world.spawnParticle("reddust", px + xOffset, py, pz + zOffset, 0, 0, 0, redstoneBrightness);
+    }
 
 }
